<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Common_model extends CI_Model {

    public function addContactUs($arrData = array())
	{
		$this->db->insert('contact_us',$arrData);
		$id = $this->db->insert_id();
		return $id;
	}

	public function add_lead_phone($arrData = array())
	{
		$this->db->insert('lead_phone',$arrData);
		$fldi_lead_id = $this->db->insert_id();

		return $fldi_lead_id;
	}
	
	public function chk_phone_exists($phone='',$id='')
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('lead_phone');
		$this->db->where('fldv_phone',trim($phone));

		if(!empty($id))
		{
			$this->db->where('fldi_lead_id !=',(int)$id);
		}
		
		$query = $this->db->get();
		$flag = 0;
		if ($query->num_rows() > 0)
		{

			$flag = 1;
		}
		return $flag;
	}
	
	public function update_lead($arrData = array(),$hdn_id = 0)
	{
		$this->db->where('fldi_lead_id',$hdn_id);
		$this->db->update('tsxfarmerdetails',$arrData);
		return true;
	}
	
	public function update_lead_phone($arrData = array(),$id=0)
	{
		$this->db->where('fldi_lead_phone_id',$id);
		$this->db->update('lead_phone',$arrData);
		return true;
	}
	
	public function insert_lead_attribute($arrData = array(), $arrFieldInfo = array())
	{
		$flgAttributeId	= $this->chk_lead_attribute_exists($arrData,$arrFieldInfo);

		if(!($flgAttributeId))
		{
			$this->db->insert('lead_attr_'.$arrFieldInfo['flg_type'], $arrData);
		}
		else
		{
			unset($arrData['fldi_added_by']);
			unset($arrData['flddt_date_added']);
			
			$this->db->where('fldi_lead_id',(int)$arrData['fldi_lead_id']);
			$this->db->where('fldi_lead_attr_id',(int)$arrData['fldi_lead_attr_id']);
			$this->db->update('lead_attr_'.$arrFieldInfo['flg_type'], $arrData);
		}
	}

	public function chk_lead_attribute_exists($arrData = array(), $arrFieldInfo = array())
	{
		$this->db->select('fldi_id,fldi_lead_id,fldi_lead_attr_id');
		$this->db->from('lead_attr_'.$arrFieldInfo['flg_type']);
		$this->db->where('fldi_lead_id',(int)$arrData['fldi_lead_id']);
		$this->db->where('fldi_lead_attr_id',(int)$arrData['fldi_lead_attr_id']);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$arrData =  $query->row_array();
			return $arrData['fldi_id'];
		}

		return false;
	}
	
	public function get_attribute_value($arrFieldInfo = array(),$lead_id='')
	{
		$this->db->select('fldi_id,fldi_lead_id,fldi_lead_attr_id,fldv_value');
		$this->db->from('lead_attr_'.$arrFieldInfo['flg_type']);
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->where('fldi_lead_attr_id',(int)$arrFieldInfo['fldi_id']);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$arrData =  $query->row_array();
			return $arrData;
		}
		return false;
	}
	
	public function get_lead_id_by_phone($phone = '',$lead_id = 0)
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('lead_phone');
		$this->db->where('fldv_phone',$this->db->escape_str($phone));
		$this->db->where('flg_is_deleted',0);
		$query = $this->db->get();
		$data['totalRows']   = $query->num_rows();
		$cust_lead_id		 = 0;
		if ( $data['totalRows']  > 0)
		{
			 $arrData 			 = $query->row_array();
			 $cust_lead_id		 = $arrData['fldi_lead_id'];
		}
		return $cust_lead_id;

	}
	
	public function chk_primary_email_exists($lead_id='')
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('lead_email');
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->where('flg_is_primary',1);
		$this->db->where('flg_is_deleted',0);
		$query = $this->db->get();
		$flag = 0;
		if ($query->num_rows() > 0)
		{
			$flag = 1;
		}
		return $flag;
	}
	
	public function check_and_add_lead_email($arrData = array())
	{
		$flg_exists = $this->chk_email_exists($arrData['fldv_email']);

		if(!$flg_exists)
		{
			$this->db->insert('lead_email',$arrData);
			$fldi_lead_id = $this->db->insert_id();

			return $fldi_lead_id;
		}
	}

	public function chk_email_exists($useremail='',$lead_id='')
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('lead_email');
		$this->db->where('fldv_email',trim($useremail));
		if(trim($lead_id) != '')
		{
			$this->db->where('fldi_lead_id !=',(int)$lead_id);
		}
		$query = $this->db->get();
		return $query->num_rows();
	}
	
	public function get_total_lead($data = array())
	{

		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		
		//map table only if search in phone
		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$this->db->join('lead_phone as lp','lm.fldi_lead_id = lp.fldi_lead_id');
		}
		
		if(isset($data['state']) && trim($data['state']) != '')
		{
			$this->db->where('lm.Statecode',$this->db->escape_str($data['state']));
		}
		
		if(isset($data['dname']) && !empty($data['dname']))
		{
			if(is_array($data['dname']) && count($data['dname'])>0)
			{
				$this->db->where_in('Districtname',($data['dname']));
			}//
			else if(!empty($data['dname'])){
				$this->db->where('Districtname',$this->db->escape_str($data['dname']));
			}
			
		}
		
		if(isset($data['tname']) && !empty($data['tname']))
		{
			$this->db->where('Tehsilname',$this->db->escape_str($data['tname']));
		}
		
		if(isset($data['vname']) && !empty($data['vname']))
		{
			$arrVillage	= explode('~~~',$data['vname']);
			
			$this->db->where('Villagename',$this->db->escape_str($arrVillage[1]));
		}
		
		if(isset($data['did']) && !empty($data['did']))
		{
			if(!is_array($data['did']))
			{
				$data['did']	= array($data['did']);
			}
			$this->db->where_in('lm.flg_status',$data['did']);
		}

		if(isset($data['ls']) && !empty($data['ls']))
		{
			if(!is_array($data['ls']))
			{
				$data['ls']	= array($data['ls']);
			}
			$this->db->where_in('lm.flg_is_positive',$data['ls']);
		}

		if(isset($data['cs']) && trim($data['cs']) != '')
		{
			if(trim(strtolower($data['cs'])) == 'called')
			{
				$this->db->where('lm.fldi_attempted >', 0);
			}
			else if(trim(strtolower($data['cs'])) == 'pending')
			{
				$this->db->where('lm.fldi_attempted',0);
			}
		}

		if(isset($data['connect']) && trim($data['connect']) != '')
		{
			$arrConnect = explode('~',$data['connect']);
			if(trim($arrConnect[0]) == '1+')
			{
				$this->db->where('lm.fldi_connected >=',1);
			}
			else
			{
				$this->db->where('lm.fldi_connected >=',(int)trim($arrConnect[0]));
				$this->db->where('lm.fldi_connected <=',(int)trim($arrConnect[1]));
			}
			
		}
		
		if(isset($data['attempt']) && trim($data['attempt']) != '')
		{
			if(isset($data['attcon']) && trim($data['attcon']) != '')
			{
				$search_cond	= trim($data['attcon']);
				switch($search_cond)
				{
					case '=':
						$this->db->where('lm.fldi_attempted',(int)trim($data['attempt']));
						break;
					case '<':
						$this->db->where('lm.fldi_attempted <',(int)trim($data['attempt']));
						break;
					case '>':
						$this->db->where('lm.fldi_attempted >',(int)trim($data['attempt']));
						break;
					case '<=':
						$this->db->where('lm.fldi_attempted <=',(int)trim($data['attempt']));
						break;
					case '>=':
						$this->db->where('lm.fldi_attempted >=',(int)trim($data['attempt']));
						break;
					case 'between':
						$arrConnect = explode('~',$data['attempt']);
						$this->db->where('lm.fldi_attempted >=',(int)trim($arrConnect[0]));
						$this->db->where('lm.fldi_attempted <=',(int)trim($arrConnect[1]));
						break;
					default;
						$this->db->where('lm.fldi_attempted',(int)trim($data['attempt']));
						break;
				}
			}
			else
			{
			$arrConnect = explode('~',$data['attempt']);
			if(trim($arrConnect[0]) == '10+')
			{
				$this->db->where('lm.fldi_attempted >=',10);
			}
			else
			{
				$this->db->where('lm.fldi_attempted >=',(int)trim($arrConnect[0]));
				$this->db->where('lm.fldi_attempted <=',(int)trim($arrConnect[1]));
			}
			}				
		}
		
		if(isset($data['aid']) && !empty($data['aid']))
		{
			if(!is_array($data['aid']))
			{
				$data['aid']	= array($data['aid']);
			}
			$this->db->where_in('lm.fldi_agent_id',$data['aid']);
		}

		if(isset($data['fa']) && trim($data['fa']) != '')
		{
			if(trim(strtolower($data['fa'])) == 'allocated')
			{
				$this->db->where('lm.fldi_agent_id !=', 0);
			}
			else if(trim(strtolower($data['fa'])) == 'notallocated')
			{
				$this->db->where('lm.fldi_agent_id',0);
			}
		}

		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$phone	= $this->db->escape_str($data['phone']);
			$wherestr = '(lp.fldv_phone like "%'.$phone.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['email']) && trim($data['email'])!='')
		{
			$email	= $this->db->escape_str($data['email']);
			$wherestr = '(Emailid like "'.$email.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['registered']) && trim($data['registered']) != '')
		{
			$this->db->where('lm.flg_viewed',(int)$data['registered']);
		}
		
		if(isset($data['ob']) && trim($data['ob']) != '')
		{
			$this->db->where('lm.flg_lead_type',(int)$data['ob']);
		}
		
		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d H:i:00', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d 00:00:00', strtotime($date));
			}
			

			$this->db->where('lm.ModifiedDate >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d H:i:59', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d 23:59:59', strtotime($date));
			}

			$this->db->where('lm.ModifiedDate <=',$ed);
		}

		if(isset($data['csd']) && trim($data['csd']) != '')
		{
			$var = $data['csd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d H:i:00', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d 00:00:00', strtotime($date));
			}
			$this->db->where('lm.flddt_calling_date >=',$sd);
		}

		if(isset($data['ced']) && trim($data['ced']) != '')
		{
			$var = $data['ced'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d H:i:59', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d 23:59:59', strtotime($date));
			}
			$this->db->where('lm.flddt_calling_date <=',$ed);
		}

		if(isset($data['sname']) && trim($data['sname'])!='')
		{
			$sname	= $this->db->escape_str($data['sname']);
			$this->db->where("lm.fldv_lead_source", $sname);
		}
		
		if(isset($data['name']) && trim($data['name'])!='')
		{
			$name	= $this->db->escape_str($data['name']);
			$this->db->where("(CONCAT(lm.Farmername, ' ', lm.Fathername) LIKE '%".$name."%')", NULL, false);
		}
		
		if(isset($data['gid']) && !empty($data['gid']))
		{
			if(!is_array($data['gid']))
			{
				$data['gid']	= array($data['gid']);
			}
			$this->db->where_in('lm.fldi_last_group_id',$data['gid']);
		}
		$this->db->where('lm.flg_is_deleted',0);
		$query = $this->db->get();

		$total_records =   $query->num_rows();
		return  $total_records;
	}

	public function get_leads($limit='10', $page_num='0',$data = array())
	{
		$order_by	= isset($data['ord_by'])?$data['ord_by']:'';
		$ordertype	= isset($data['ord_type'])?$data['ord_type']:'desc';
		switch($order_by)
		{
			case 'lid':
				$orderby = 'lm.fldi_lead_id';
				break;
			case 'ltid':
				$orderby = 'lm.fldi_lead_id';
				break;
			default:
				$orderby = 'lm.fldi_lead_id';
				break;
		}

		$start = ($page_num  == NULL) ? 0 :($page_num * $limit) - $limit;
		if($start <0)
		{
			$start = 0;
		}

		$this->db->select('lm.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email,lm.flddt_date_added as date_added');
		$this->db->from('tsxfarmerdetails as lm');
			$this->db->join('tbl_lead_solutions as lp','lm.fldi_lead_id = lp.fldi_lead_id');
		//map table only if search in phone
		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$this->db->join('lead_phone as lp','lm.fldi_lead_id = lp.fldi_lead_id');
		}
		
		if(isset($data['state']) && trim($data['state']) != '')
		{
			$this->db->where('lm.Statecode',$this->db->escape_str($data['state']));
		}
		
		if(isset($data['dname']) && !empty($data['dname']))
		{
			if(is_array($data['dname']) && count($data['dname'])>0)
			{
				$this->db->where_in('Districtname',($data['dname']));
			}//
			else if(!empty($data['dname'])){
				$this->db->where('Districtname',$this->db->escape_str($data['dname']));
			}
		}
		
		if(isset($data['tname']) && !empty($data['tname']))
		{
			$this->db->where('Tehsilname',$this->db->escape_str($data['tname']));
		}
		
		if(isset($data['vname']) && !empty($data['vname']))
		{
			$arrVillage	= explode('~~~',$data['vname']);
			
			$this->db->where('Villagename',$this->db->escape_str($arrVillage[1]));
		}
		
		if(isset($data['did']) && !empty($data['did']))
		{
			if(!is_array($data['did']))
			{
				$data['did']	= array($data['did']);
			}
			$this->db->where_in('lm.flg_status',$data['did']);
		}

		if(isset($data['ls']) && !empty($data['ls']))
		{
			if(!is_array($data['ls']))
			{
				$data['ls']	= array($data['ls']);
			}
			$this->db->where_in('lm.flg_is_positive',$data['ls']);
		}

		if(isset($data['cs']) && trim($data['cs']) != '')
		{
			if(trim(strtolower($data['cs'])) == 'called')
			{
				$this->db->where('lm.fldi_attempted >', 0);
			}
			else if(trim(strtolower($data['cs'])) == 'pending')
			{
				$this->db->where('lm.fldi_attempted',0);
			}
		}

		if(isset($data['connect']) && trim($data['connect']) != '')
		{
			$arrConnect = explode('~',$data['connect']);
			if(trim($arrConnect[0]) == '1+')
			{
				$this->db->where('lm.fldi_connected >=',1);
			}
			else
			{
				$this->db->where('lm.fldi_connected >=',(int)trim($arrConnect[0]));
				$this->db->where('lm.fldi_connected <=',(int)trim($arrConnect[1]));
			}
			
		}
		
		if(isset($data['attempt']) && trim($data['attempt']) != '')
		{
			if(isset($data['attcon']) && trim($data['attcon']) != '')
			{
				$search_cond	= trim($data['attcon']);
				switch($search_cond)
				{
					case '=':
						$this->db->where('lm.fldi_attempted',(int)trim($data['attempt']));
						break;
					case '<':
						$this->db->where('lm.fldi_attempted <',(int)trim($data['attempt']));
						break;
					case '>':
						$this->db->where('lm.fldi_attempted >',(int)trim($data['attempt']));
						break;
					case '<=':
						$this->db->where('lm.fldi_attempted <=',(int)trim($data['attempt']));
						break;
					case '>=':
						$this->db->where('lm.fldi_attempted >=',(int)trim($data['attempt']));
						break;
					case 'between':
						$arrConnect = explode('~',$data['attempt']);
						$this->db->where('lm.fldi_attempted >=',(int)trim($arrConnect[0]));
						$this->db->where('lm.fldi_attempted <=',(int)trim($arrConnect[1]));
						break;
					default;
						$this->db->where('lm.fldi_attempted',(int)trim($data['attempt']));
						break;
				}
			}
			else
			{
			$arrConnect = explode('~',$data['attempt']);
			if(trim($arrConnect[0]) == '10+')
			{
				$this->db->where('lm.fldi_attempted >=',10);
			}
			else
			{
				$this->db->where('lm.fldi_attempted >=',(int)trim($arrConnect[0]));
				$this->db->where('lm.fldi_attempted <=',(int)trim($arrConnect[1]));
			}
			}				
		}
		
		if(isset($data['aid']) && !empty($data['aid']))
		{
			if(!is_array($data['aid']))
			{
				$data['aid']	= array($data['aid']);
			}
			$this->db->where_in('lm.fldi_agent_id',$data['aid']);
		}

		if(isset($data['fa']) && trim($data['fa']) != '')
		{
			if(trim(strtolower($data['fa'])) == 'allocated')
			{
				$this->db->where('lm.fldi_agent_id !=', 0);
			}
			else if(trim(strtolower($data['fa'])) == 'notallocated')
			{
				$this->db->where('lm.fldi_agent_id',0);
			}
		}

		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$phone	= $this->db->escape_str($data['phone']);
			$wherestr = '(lp.fldv_phone like "%'.$phone.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['email']) && trim($data['email'])!='')
		{
			$email	= $this->db->escape_str($data['email']);
			$wherestr = '(Emailid like "'.$email.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['registered']) && trim($data['registered']) != '')
		{
			$this->db->where('lm.flg_viewed',(int)$data['registered']);
		}
		
		if(isset($data['ob']) && trim($data['ob']) != '')
		{
			$this->db->where('lm.flg_lead_type',(int)$data['ob']);
		}
		
		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d H:i:00', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d 00:00:00', strtotime($date));
			}
			

			$this->db->where('lm.ModifiedDate >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d H:i:59', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d 23:59:59', strtotime($date));
			}

			$this->db->where('lm.ModifiedDate <=',$ed);
		}

		if(isset($data['csd']) && trim($data['csd']) != '')
		{
			$var = $data['csd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d H:i:00', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d 00:00:00', strtotime($date));
			}
			$this->db->where('lm.flddt_calling_date >=',$sd);
		}

		if(isset($data['ced']) && trim($data['ced']) != '')
		{
			$var = $data['ced'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d H:i:59', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d 23:59:59', strtotime($date));
			}
			$this->db->where('lm.flddt_calling_date <=',$ed);
		}

		if(isset($data['sname']) && trim($data['sname'])!='')
		{
			$sname	= $this->db->escape_str($data['sname']);
			$this->db->where("lm.fldv_lead_source", $sname);
		}
		
		if(isset($data['name']) && trim($data['name'])!='')
		{
			$name	= $this->db->escape_str($data['name']);
			$this->db->where("(CONCAT(lm.Farmername, ' ', lm.Fathername) LIKE '%".$name."%')", NULL, false);
		}
		
		if(isset($data['gid']) && !empty($data['gid']))
		{
			if(!is_array($data['gid']))
			{
				$data['gid']	= array($data['gid']);
			}
			$this->db->where_in('lm.fldi_last_group_id',$data['gid']);
		}
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->limit($limit, $start);
		$this->db->order_by($orderby.' '.$ordertype );
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_other_phones($lead_id=0)
	{
		$this->db->select('lp.fldv_phone');
		$this->db->from('lead_phone lp');
		$this->db->where('lp.fldi_lead_id',(int)$lead_id);
		$this->db->where('lp.flg_is_primary',0);
		$this->db->where('lp.flg_is_deleted',0);
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_other_emails($lead_id=0)
	{
		$this->db->select('le.fldv_email');
		$this->db->from('lead_email le');
		$this->db->where('le.fldi_lead_id',(int)$lead_id);
		$this->db->where('le.flg_is_primary',0);
		$this->db->where('le.flg_is_deleted',0);
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_lead_by_id($id = '')
	{
		$this->db->select('lm.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->where('lm.fldi_lead_id',(int)$id);
		$this->db->where('lm.flg_is_deleted',0);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->row_array();
		}
		return false;
	}

	public function get_lead_by_ids($id = array())
	{
		$this->db->select('lm.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->where_in('lm.fldi_lead_id',$id);
		$this->db->where('lm.flg_is_deleted',0);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function delete_lead($hdn_id = 0)
	{
		$arrData	= array('flg_is_deleted'=>1,
							'flddt_date_updated'=>date('Y-m-d H:i:s'),
							'fldi_updated_by'=>$this->crm_auth->get_id());

		if(is_array($hdn_id) && count($hdn_id)>0)
		{
			$this->db->where_in('fldi_lead_id',$hdn_id);
		}
		else
		{
			$this->db->where('fldi_lead_id',$hdn_id);
		}
		$this->db->update('tsxfarmerdetails',$arrData);
		
		//update lead phone
		$arrLeadData 	= array('flg_is_deleted'=>1);
		if(is_array($hdn_id) && count($hdn_id)>0)
		{
			$this->db->where_in('fldi_lead_id',$hdn_id);
		}
		else
		{
			$this->db->where('fldi_lead_id',$hdn_id);
		}
		$this->db->update('lead_phone',$arrLeadData);
		
		//update lead phone
		if(is_array($hdn_id) && count($hdn_id)>0)
		{
			$this->db->where_in('fldi_lead_id',$hdn_id);
		}
		else
		{
			$this->db->where('fldi_lead_id',$hdn_id);
		}
		$this->db->update('lead_email',$arrLeadData);
		return true;
	}

	public function get_all_disposition_status($dispose_id = 0)
	{
		$this->db->select('fldi_disposition_id,fldv_disposition_code,fldv_disposition_name');
		$this->db->from('disposition_status');
		$this->db->where('fldi_parent_id',$dispose_id);
		$this->db->where('flg_status',1);
		$this->db->where('flg_is_deleted',0);
		$this->db->order_by('fldv_disposition_name','ASC');
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	public function get_disposition_by_id($dispose_id = 0)
	{
		$this->db->select('fldi_disposition_id,fldv_disposition_code,fldv_disposition_name');
		$this->db->from('disposition_status');
		$this->db->where('fldi_disposition_id',$dispose_id);
		$this->db->where('flg_status',1);
		$this->db->where('flg_is_deleted',0);
		$this->db->order_by('fldv_disposition_name','ASC');
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->row_array();
		}
		return false;
	}
	
	public function get_farmer_requirement_info($Farmerid = '')
	{
		$this->db->from('lead_solutions');
		$this->db->where('fldv_farmer_id',$Farmerid);
		$query 				 = $this->db->get();
		
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function get_duplicate_lead_by_phone($phone = '',$lead_id = 0)
	{
		$this->db->select('lm.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->where('lm.Mobileno',$this->db->escape_str($phone));
		$this->db->where('lm.fldi_lead_id !=',(int)$lead_id);
		$this->db->where('lm.flg_is_deleted',0);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_total_lead_fupi($data = array())
	{

		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->join('tfupiintervention as lp','lm.Farmerid = lp.FarmerCode AND lm.DealerCode = lp.DealerCode');
		if(isset($data['leadid']) && !empty($data['leadid']))
		{
			if(!is_array($data['leadid']))
			{
				$data['leadid']	= array($data['leadid']);
			}
			$this->db->where_in('lm.fldi_lead_id',$data['leadid']);
		}
		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$phone	= $this->db->escape_str($data['phone']);
			$wherestr = '(lm.Mobileno like "%'.$phone.'%")';
			$this->db->where($wherestr);
		}
		if(isset($data['crop']) && trim($data['crop'])!='')
		{
			$crop	= $this->db->escape_str($data['crop']);
			$wherestr = '(lp.FUPIGrpCode like "%'.$crop.'")';
			$this->db->where($wherestr);
		}

		if(isset($data['email']) && trim($data['email'])!='')
		{
			$email	= $this->db->escape_str($data['email']);
			$wherestr = '(lm.Emailid like "'.$email.'%")';
			$this->db->where($wherestr);
		}
		
		if(isset($data['actby']) && trim($data['actby'])!='')
		{
			$this->db->where('lp.ActionBy',$this->db->escape_str($data['actby']));
		}

		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d 00:00:00', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d', strtotime($date));
			}
			

			$this->db->where('lp.ExpInterventionDate >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d 23:59:59', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d', strtotime($date));
			}

			$this->db->where('lp.ExpInterventionDate <=',$ed);
		}

		if(isset($data['name']) && trim($data['name'])!='')
		{
			$name	= $this->db->escape_str($data['name']);
			$this->db->where("(CONCAT(lm.Farmername, ' ', lm.Fathername) LIKE '%".$name."%')", NULL, false);
		}
		$this->db->where('lm.flg_is_deleted',0);
		
		$query = $this->db->get();

		$total_records =   $query->num_rows();
		return  $total_records;
	}

	public function get_leads_fupi($limit='10', $page_num='0',$data = array())
	{
		$order_by	= isset($data['ord_by'])?$data['ord_by']:'';
		$ordertype	= isset($data['ord_type'])?$data['ord_type']:'desc';
		switch($order_by)
		{
			case 'lid':
				$orderby = 'lm.fldi_lead_id';
				break;
			case 'ltid':
				$orderby = 'lt.fldi_lead_track_id';
				break;
			default:
				$orderby = 'lm.fldi_lead_id';
				break;
		}

		$start = ($page_num  == NULL) ? 0 :($page_num * $limit) - $limit;
		if($start <0)
		{
			$start = 0;
		}

		$this->db->select('lp.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email,lm.SamriddhiFarmerId,lm.Farmerid,lm.Farmername,lm.Fathername,lm.fldi_lead_id');
		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->join('tfupiintervention as lp','lm.Farmerid = lp.FarmerCode AND lm.DealerCode = lp.DealerCode');
		if(isset($data['leadid']) && !empty($data['leadid']))
		{
			if(!is_array($data['leadid']))
			{
				$data['leadid']	= array($data['leadid']);
			}
			$this->db->where_in('lm.fldi_lead_id',$data['leadid']);
		}
		if(isset($data['crop']) && trim($data['crop'])!='')
		{
			$crop	= $this->db->escape_str($data['crop']);
			$wherestr = '(lp.FUPIGrpCode like "%'.$crop.'")';
			$this->db->where($wherestr);
		}
		
		$this->db->where('lm.flg_is_deleted',0);
		
		if(isset($data['actby']) && trim($data['actby'])!='')
		{
			$this->db->where('lp.ActionBy',$this->db->escape_str($data['actby']));
		}
		
		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$phone	= $this->db->escape_str($data['phone']);
			$wherestr = '(lm.Mobileno like "%'.$phone.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['email']) && trim($data['email'])!='')
		{
			$email	= $this->db->escape_str($data['email']);
			$wherestr = '(lm.Emailid like "'.$email.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d 00:00:00', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d', strtotime($date));
			}
			

			$this->db->where('lp.ExpInterventionDate >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d 23:59:59', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d', strtotime($date));
			}

			$this->db->where('lp.ExpInterventionDate <=',$ed);
		}

		if(isset($data['name']) && trim($data['name'])!='')
		{
			$name	= $this->db->escape_str($data['name']);
			$this->db->where("(CONCAT(lm.Farmername, ' ', lm.Fathername) LIKE '%".$name."%')", NULL, false);
		}
		
		$this->db->limit($limit, $start);
		$this->db->order_by($orderby.' '.$ordertype );
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}

	public function get_fupi_by_fupiid($fupiid = 0)
	{
		$this->db->select('lp.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email,lm.SamriddhiFarmerId,lm.Farmerid,lm.Farmername,lm.Fathername,lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->join('tfupiintervention as lp','lm.Farmerid = lp.FarmerCode AND lm.DealerCode = lp.DealerCode');
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->where('lp.fldi_id',(int)$fupiid);
		
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}


	public function get_all_fupi_by_farmer($farmer_id,$DealerCode)
	{
		$this->db->select('lp.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email,lm.SamriddhiFarmerId,lm.Farmerid,lm.Farmername,lm.Fathername,lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->join('tfupiintervention as lp','lm.Farmerid = lp.FarmerCode AND lm.DealerCode = lp.DealerCode');
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->where('lp.FarmerCode',$farmer_id);
		$this->db->where('lp.DealerCode',$DealerCode);
		//$this->db->order_by('lp.ExpInterventionDate','desc');
		
		
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}

	public function update_lead_fupi($arrData = array(),$fupi_id = 0)
	{
		$this->db->where('fldi_id',(int)$fupi_id);
		$this->db->update('tfupiintervention',$arrData);
		return true;  
	}

	public function get_fupi_tosend($hdn_fupi_id = '')
	{
		$this->db->from('tfupiintervention');
		$this->db->where('flg_transferred',0);
		if(!empty($hdn_fupi_id))
		{
			$this->db->where('fldi_id',(int)$hdn_fupi_id);	
		}
		$query 				 = $this->db->get();
		
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->result_array();
			 $query->free_result();
			 return $arrData;
		}
		return false;
	   
	}

	public function get_total_lead_notes($data = array())
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('lead_notes');
		$this->db->where('fldi_lead_id',(int)$data['lid']);

		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d 00:00:00', strtotime($date));

			$this->db->where('flddt_date_added >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d 23:59:59', strtotime($date));

			$this->db->where('flddt_date_added <=',$ed);
		}

		if(isset($data['aid']) && trim($data['aid']) != '')
		{
			$this->db->where('fldi_added_by',(int)$data['aid']);
		}
		$total_records =   $this->db->count_all_results();

		return  $total_records;
	}

	public function get_lead_notes($limit='10', $page_num='0',$data = array())
	{
		$start = ($page_num  == NULL) ? 0 :($page_num * $limit) - $limit;
		if($start <0)
		{
			$start = 0;
		}

		$this->db->select('lh.*,am.fldv_name');
		$this->db->from('lead_notes lh');
		$this->db->join('admin_master am','am.fldi_admin_id = lh.fldi_added_by','left');
		$this->db->where('lh.fldi_lead_id',(int)$data['lid']);
		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d 00:00:00', strtotime($date));

			$this->db->where('lh.flddt_date_added >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d 23:59:59', strtotime($date));

			$this->db->where('lh.flddt_date_added <=',$ed);
		}

		if(isset($data['aid']) && trim($data['aid']) != '')
		{
			$this->db->where('lh.fldi_added_by',(int)$data['aid']);
		}
		$this->db->order_by('lh.fldi_lead_notes_id','desc');
		$this->db->limit($limit, $start);

		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
   }

	public function get_total_lead_history($data = array())
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('lead_history');
		$this->db->where('fldi_lead_id',(int)$data['lid']);

		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d 00:00:00', strtotime($date));

			$this->db->where('flddt_date_added >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d 23:59:59', strtotime($date));

			$this->db->where('flddt_date_added <=',$ed);
		}

		if(isset($data['aid']) && trim($data['aid']) != '')
		{
			$this->db->where('fldi_added_by',(int)$data['aid']);
		}

		if(isset($data['did']) && trim($data['did']) != '')
		{
			$this->db->where('fldi_disposition_id',(int)$data['did']);
		}

		if(isset($data['ht']) && trim($data['ht']) != '')
		{
			$this->db->where('flg_history_type',(int)$data['ht']);
		}

		$total_records =   $this->db->count_all_results();

		return  $total_records;
	}

	public function get_lead_histories($limit='10', $page_num='0',$data = array())
	{
		$start = ($page_num  == NULL) ? 0 :($page_num * $limit) - $limit;
		if($start <0)
		{
			$start = 0;
		}

		$this->db->select('lh.*,am.fldv_name');
		$this->db->from('lead_history lh');
		$this->db->join('admin_master am','am.fldi_admin_id = lh.fldi_added_by','left');
		$this->db->where('lh.fldi_lead_id',(int)$data['lid']);
		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d 00:00:00', strtotime($date));

			$this->db->where('lh.flddt_date_added >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d 23:59:59', strtotime($date));

			$this->db->where('lh.flddt_date_added <=',$ed);
		}

		if(isset($data['aid']) && trim($data['aid']) != '')
		{
			$this->db->where('lh.fldi_added_by',(int)$data['aid']);
		}

		if(isset($data['did']) && trim($data['did']) != '')
		{
			$this->db->where('lh.fldi_disposition_id',(int)$data['did']);
		}

		if(isset($data['ht']) && trim($data['ht']) != '')
		{
			$this->db->where('lh.flg_history_type',(int)$data['ht']);
		}
		$this->db->limit($limit, $start);
		$this->db->order_by('lh.flddt_date_added','desc');

		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
   }

   public function add_answer_history($arrData = array())
	{
		$this->db->insert('lead_answerhistory',$arrData);
		$fldi_answer_id = $this->db->insert_id();
		return $fldi_answer_id;
	}
	
	public function add_lead_answer($arrData = array())
	{
		$this->db->insert('lead_answer',$arrData);
		$fldi_answer_id = $this->db->insert_id();
		//print_r($this->db->last_query());
		return $fldi_answer_id;
	}
	
	public function check_and_add_answer($arrData = array())
	{
		$fldi_ans_id = $this->chk_answer_exists($arrData);

		if(!$fldi_ans_id)
		{
			$this->db->insert('lead_answer',$arrData);
			$fldi_answer_id = $this->db->insert_id();
			return $fldi_answer_id;
		}//
		else
		{
			$this->db->where('fldi_ans_id',(int)$fldi_ans_id);
			$this->db->update('lead_answer',$arrData);
			return $fldi_ans_id;
		}
	}

	public function chk_answer_exists($arrData = array())
	{
		$this->db->select('fldi_ans_id');
		$this->db->from('lead_answer');
		$this->db->where('fldi_ques_id',(int)$arrData['fldi_ques_id']);
		$this->db->where('fldi_lead_id =',(int)$arrData['fldi_lead_id']);
		$query 				 = $this->db->get();
		$cust_ans_id		 = 0;
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 $cust_ans_id		 = $arrData['fldi_ans_id'];
		}
		return $cust_ans_id;
	}
	
	public function update_jam_mechanization($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxmechanization',$arrData);
		return true;
	}


	public function update_jam_implementsowned($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		//$this->db->where('Implementcode',$arrData['Implementcode']);
		$this->db->update('tsximplementsowned',$arrData);
		return true;
	}

	public function update_jam_cropcutivation($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxcropcultivation',$arrData);
		return true;
	}

	public function update_jam_asset_owned($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxassetsowned',$arrData);
		return true;
	}

	public function update_jam_familychilddetails($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxfamilychilddetails',$arrData);
		return true;
	}

	public function update_jam_farmerdetails($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxfarmerdetails',$arrData);
		return true;
	}

	public function update_jam_iddetails($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxidproof',$arrData);
		return true;
	}

	public function update_jam_mahindraproduct($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxmahindraprodavailed',$arrData);
		return true;
	}

	public function update_jam_occupation($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('Farmerid',$jamfarmerid);
		$this->db->where('DealerCode',$dealerCode);
		$this->db->update('tsxoccupation',$arrData);
		return true;
	}
	
	public function update_jam_leadreq($arrData = array(),$jamfarmerid='',$dealerCode='')
	{
		$this->db->where('fldv_farmer_id',$jamfarmerid);
		//$this->db->where('DealerCode',$dealerCode);
		$this->db->update('lead_solutions',$arrData);
		return true;
	}
	
	public function update_jam_leadreq_samid($arrData = array(),$leadid='')
	{
		$this->db->where('fldi_lead_id',$leadid);
		$this->db->update('lead_solutions',$arrData);
		return true;
	}
	
	public function getMechanizationDetails($arrData = array())
	{
		$this->db->from('tsxmechanization');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 $query->free_result();
			 return $arrData;
		}
		return false;
	}
	
	public function add_mechanization($arrData = array())
	{
		$this->db->insert('tsxmechanization',$arrData);
		return true;
	}
	
	public function chk_and_add_mechanization($arrData = array())
	{
		$arrMechanization	= $this->getMechanizationDetails($arrData);
		
		if(empty($arrMechanization))
		{
			$this->add_mechanization($arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxmechanization',$arrData);
			return true;
		}

		return true;
	}
	
	public function getFarmImplementsDetails($arrData = array())
	{
		$this->db->from('tsximplementsowned');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		//$this->db->where('Implementcode',$arrData['Implementcode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 $query->free_result();
			 return $arrData;
		}
		return false;
	}
	
	public function add_farmimplements($arrData = array())
	{
		$this->db->insert('tsximplementsowned',$arrData);
		return true;
	}
	
	public function chk_and_add_farmimplements($arrData = array())
	{
		$arrMechanization	= $this->getFarmImplementsDetails($arrData);
		
		if(empty($arrMechanization))
		{
			$this->add_farmimplements($arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			//$this->db->where('Implementcode',$arrData['Implementcode']);
			$this->db->update('tsximplementsowned',$arrData);
			return true;
		}

		return true;
	}
	
	public function getCropClutivationDetails($arrData = array(),$limit = 0)
	{
		$this->db->from('tsxcropcultivation');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		//$this->db->where('Cropcode',$arrData['Cropcode']);
		if(!empty($limit))
		{
			$this->db->limit($limit);
		}
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->result_array();
			 $query->free_result();
			 return $arrData;
		}
		return false;
	}
	
	public function checkCropClutivationExists($arrData = array())
	{
		$this->db->from('tsxcropcultivation');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$this->db->where('Cropcode',$arrData['Cropcode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function chk_and_add_cropcultivation($arrData = array())
	{
		$arrCrops	= $this->checkCropClutivationExists($arrData);
		
		if(empty($arrCrops))
		{
			$this->db->insert('tsxcropcultivation',$arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('Cropcode',$arrData['Cropcode']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxcropcultivation',$arrData);
			return true;
		}

		return true;
	}
	
	public function getCropDateDetails($arrData = array())
	{
		$this->db->from('frmcrop_dates');
		$this->db->where('fldi_lead_id',$arrData['fldi_lead_id']);
		$this->db->where('Cropcode',$arrData['Cropcode']);
		$this->db->where('status',1);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function get_crop_stages($arrData = array())
	{
		$this->db->from('cropstage_master');
		$this->db->where('Cropcode',$arrData['Cropcode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$arrData 			 = $query->result_array();
			return $arrData;
		}
		return false;
	}
	
	public function get_crop_intervention($corp_group_id = 0)
	{
		$this->db->select('csm.*,ci.fldi_id,ci.CropGrpCode,ci.ExpInterventionDate,ci.PresInternventionDetail,ci.ActualDate,ci.LastUpdateDate');
		$this->db->where('CropGrpCode',$corp_group_id);
		$this->db->from('cropintervention as ci');
		$this->db->join('cropstage_master as csm','ci.fldi_cropstage_id = csm.fldi_stage_id','LEFT');
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$arrData 			 = $query->result_array();
			return $arrData;
		}
		return false;
	}
	
	public function add_crop_interventation($arrData = array())
	{
		$this->db->insert('cropintervention',$arrData);
		$fldi_id = $this->db->insert_id();

		return $fldi_id;
	}
	
	public function update_crop_interventation($arrData = array(),$int_id = 0)
	{
		$this->db->where('fldi_id',$int_id);
		$this->db->update('cropintervention',$arrData);
		return true;
	}
	
	public function checkCropDateExists($arrData = array())
	{
		$this->db->from('frmcrop_dates');
		$this->db->where('fldi_lead_id',$arrData['fldi_lead_id']);
		$this->db->where('Cropcode',$arrData['Cropcode']);
		$this->db->where('Harvestingdate <',$arrData['Harvestingdate']);
		$this->db->where('status',1);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	
	public function chk_and_add_cropdates($arrData = array())
	{
		$arrCropDates	= $this->checkCropDateExists($arrData);
		
		if(empty($arrCropDates))
		{
			$arrData['status']	= 0;
			$this->db->where('fldi_lead_id',$arrData['fldi_lead_id']);
			$this->db->where('Cropcode',$arrData['Cropcode']);
			$this->db->update('frmcrop_dates',$arrData);
			
			
			$arrData['status']	= 1;
			$this->db->insert('frmcrop_dates',$arrData);
			return true;
		}//
		else
		{
			unset($arrData['addedby']);
			unset($arrData['dateadded']);
			
			$this->db->where('fldi_lead_id',$arrData['fldi_lead_id']);
			$this->db->where('Cropcode',$arrData['Cropcode']);
			$this->db->where('Harvestingdate <',$arrData['Harvestingdate']);
			$this->db->where('status',1);
			$this->db->update('frmcrop_dates',$arrData);
			return true;
		}

		return true;
	}
	
	public function checkAssetOwnedExists($arrData = array())
	{
		$this->db->from('tsxassetsowned');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function chk_and_add_asset_owned($arrData = array())
	{
		$arrMechanization	= $this->checkAssetOwnedExists($arrData);
		
		if(empty($arrMechanization))
		{
			$this->db->insert('tsxassetsowned',$arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxassetsowned',$arrData);
			return true;
		}

		return true;
	}
	
	public function checkFamilyChildExists($arrData = array())
	{
		$this->db->from('tsxfamilychilddetails');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function chk_and_add_familychild_details($arrData = array())
	{
		$arrChild	= $this->checkFamilyChildExists($arrData);
		
		if(empty($arrChild))
		{
			$this->db->insert('tsxfamilychilddetails',$arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxfamilychilddetails',$arrData);
			return true;
		}

		return true;
	}
	
	public function checkFarmerExists($arrData = array())
	{
		$this->db->from('tsxfarmerdetails');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function chk_and_add_farmerdetails($arrData = array())
	{
		$arrFarmerInfo	= $this->checkFarmerExists($arrData);
		
		if(empty($arrFarmerInfo))
		{
			$this->db->insert('tsxfarmerdetails',$arrData);
			$lead_id = $this->db->insert_id();
			
			$arrPhoneData						= array();
			$arrPhoneData['fldi_lead_id'] 		= $lead_id;
			$arrPhoneData['fldv_prefix'] 		= '';
			$arrPhoneData['fldv_phone'] 		= trim($arrData['Mobileno']);
			$arrPhoneData['flg_is_primary'] 	= 1;
			$arrPhoneData['flddt_date_added'] 	= date('Y-m-d H:i:s');
			$arrPhoneData['flddt_date_updated'] = date('Y-m-d H:i:s');
			$this->add_lead_phone($arrPhoneData);
			
			return $lead_id;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxfarmerdetails',$arrData);
			return true;
		}

		return true;
	}
	
	public function checkIDDetailsExists($arrData = array())
	{
		$this->db->from('tsxidproof');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function chk_and_add_iddetails($arrData = array())
	{
		$arrMechanization	= $this->checkIDDetailsExists($arrData);
		
		if(empty($arrMechanization))
		{
			$this->db->insert('tsxidproof',$arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxidproof',$arrData);
			return true;
		}

		return true;
	}
	
	public function checkMahindraproductExists($arrData = array())
	{
		$this->db->from('tsxmahindraprodavailed');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function chk_and_add_mahindraproduct($arrData = array())
	{
		$arrMechanization	= $this->checkMahindraproductExists($arrData);
		
		if(empty($arrMechanization))
		{
			$this->db->insert('tsxmahindraprodavailed',$arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxmahindraprodavailed',$arrData);
			return true;
		}

		return true;
	}
	
	public function checkOccupationExists($arrData = array())
	{
		$this->db->from('tsxoccupation');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 return $arrData;
		}
		return false;
	}
	
	public function add_occupation($arrData = array())
	{
		$this->db->insert('tsxoccupation',$arrData);
		return true;
	}
	
	public function chk_and_add_occupation($arrData = array())
	{
		$arrMechanization	= $this->checkOccupationExists($arrData);
		
		if(empty($arrMechanization))
		{
			$this->add_occupation($arrData);
			return true;
		}//
		else
		{
			$this->db->where('Farmerid',$arrData['Farmerid']);
			$this->db->where('DealerCode',$arrData['DealerCode']);
			$this->db->update('tsxoccupation',$arrData);
			return true;
		}

		return true;
	}
	
	public function add_lead_req($arrData = array())
	{
		$this->db->insert('lead_solutions',$arrData);
		//echo $this->db->last_query(); exit;
		$fldi_id = $this->db->insert_id();
		return $fldi_id;
	}
	public function chk_lead_exists($arrData = array())
	{
		$this->db->select('fldi_lead_solution_id');
		$this->db->from('lead_solutions');
		$this->db->where('fldi_lead_id',(int)$arrData['fldi_lead_id']);
		$this->db->where('fldv_farmer_id =',$arrData['fldv_farmer_id']);
		$query 				 = $this->db->get();
		$fldi_sol_id		 = 0;
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->row_array();
			 $fldi_sol_id		 = $arrData['fldi_lead_solution_id'];
			// echo $this->db->last_query(); exit;
		}
		return $fldi_sol_id;
	}
	public function check_and_add_lead($arrData = array())
	{
		$fldi_sol_id = $this->chk_lead_exists($arrData);

		if(!$fldi_sol_id)
		{
			$this->db->insert('lead_solutions',$arrData);
			$fldi_id = $this->db->insert_id();
			//echo $this->db->last_query(); exit;
			return $fldi_id;
		}//
		else
		{
			$this->db->where('fldi_lead_solution_id',(int)$fldi_sol_id);
			$this->db->update('lead_solutions',$arrData);
			//echo $this->db->last_query(); exit;
			return $fldi_sol_id;
		}
	}
	
	public function add_notes($arrData = array())
	{
		$this->db->insert('lead_notes',$arrData);
		$fldi_lead_id = $this->db->insert_id();

		return $fldi_lead_id;
	}
	
	public function get_all_phones($lead_id=0)
	{
		$this->db->select('lp.flg_is_primary,lp.fldv_phone');
		$this->db->from('lead_phone lp');
		$this->db->where('lp.fldi_lead_id',(int)$lead_id);
		$this->db->where('lp.flg_is_deleted',0);
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function add_history($arrData = array())
	{
		$this->db->insert('lead_history',$arrData);
		$fldi_history_id = $this->db->insert_id();

		return $fldi_history_id;
	}

	public function allocate_add_lead_history($lead_id='', $agent_id = 0)
	{
		$flgAlreadyAllocated	= $this->chk_lead_already_assigned($lead_id,$agent_id);

		if(!($flgAlreadyAllocated))
		{
			$data = array('fldi_lead_id' 	=> $lead_id,
					  'fldi_agent_id' 	=> $agent_id,
					  'flddt_date_added'=> date('Y-m-d H:i:s'),
					  'fldi_added_by'	=>'-1');
			$this->db->insert('lead_allocation_history', $data);
		}
	}

	public function chk_lead_already_assigned($lead_id='', $agent_id = 0)
	{
		$this->db->select('fldi_lead_id,fldi_agent_id');
		$this->db->from('tsxfarmerdetails');
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->where('fldi_agent_id',$agent_id);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			$arrData =  $query->row_array();
			return $arrData['fldi_agent_id'];
		}

		return false;
	}

	public function updateLeadConnected($lead_id='')
	{
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->set('fldi_connected',"fldi_connected+1",FALSE);
		$this->db->update('tsxfarmerdetails');
	}
	
	public function updateLeadAttempted($lead_id='')
	{
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->set('fldi_attempted',"fldi_attempted+1",FALSE);
		$this->db->update('tsxfarmerdetails');
	}

	public function updateLeadCallConnected($lead_id='')
	{
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->set('fldi_call_connected',"fldi_call_connected+1",FALSE);
		$this->db->update('tsxfarmerdetails');
	}

	public function updateLeadCallback($lead_id='')
	{
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->set('fldi_callback',"fldi_callback+1",FALSE);
		$this->db->update('tsxfarmerdetails');
	}

	public function get_total_lead_req($data = array())
	{

		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->join('tbl_lead_solutions as lp','lm.fldi_lead_id = lp.fldi_lead_id');
		if(isset($data['pcode']) && !empty($data['pcode']))
		{
			if(!is_array($data['pcode']))
			{
				$data['pcode']	= array($data['pcode']);
			}
			$this->db->where_in('lp.fldv_solutions_category',$data['pcode']);
		}

		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$phone	= $this->db->escape_str($data['phone']);
			$wherestr = '(lm.Mobileno like "%'.$phone.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['email']) && trim($data['email'])!='')
		{
			$email	= $this->db->escape_str($data['email']);
			$wherestr = '(lm.Emailid like "'.$email.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d', strtotime($date));
			}
			

			$this->db->where('lp.flddt_exp_purchase >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d', strtotime($date));
			}

			$this->db->where('lp.flddt_exp_purchase <=',$ed);
		}

		if(isset($data['name']) && trim($data['name'])!='')
		{
			$name	= $this->db->escape_str($data['name']);
			$this->db->where("(CONCAT(lm.Farmername, ' ', lm.Fathername) LIKE '%".$name."%')", NULL, false);
		}
		$this->db->where('lm.flg_is_deleted',0);
		
		$query = $this->db->get();

		$total_records =   $query->num_rows();
		return  $total_records;
	}

	public function get_leads_req($limit='10', $page_num='0',$data = array())
	{
		$order_by	= isset($data['ord_by'])?$data['ord_by']:'';
		$ordertype	= isset($data['ord_type'])?$data['ord_type']:'desc';
		switch($order_by)
		{
			case 'lid':
				$orderby = 'lm.fldi_lead_id';
				break;
			case 'ltid':
				$orderby = 'lm.fldi_lead_id';
				break;
			default:
				$orderby = 'lm.fldi_lead_id';
				break;
		}

		$start = ($page_num  == NULL) ? 0 :($page_num * $limit) - $limit;
		if($start <0)
		{
			$start = 0;
		}

		$this->db->select('lp.*,lm.Mobileno as fldv_phone,lm.Emailid as fldv_email,lm.SamriddhiFarmerId,lm.Farmerid,lm.Farmername,lm.Fathername');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->join('tbl_lead_solutions as lp','lm.fldi_lead_id = lp.fldi_lead_id');
		if(isset($data['pcode']) && !empty($data['pcode']))
		{
			if(!is_array($data['pcode']))
			{
				$data['pcode']	= array($data['pcode']);
			}
			$this->db->where_in('lp.fldv_solutions_category',$data['pcode']);
		}

		if(isset($data['phone']) && trim($data['phone'])!='')
		{
			$phone	= $this->db->escape_str($data['phone']);
			$wherestr = '(lm.Mobileno like "%'.$phone.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['email']) && trim($data['email'])!='')
		{
			$email	= $this->db->escape_str($data['email']);
			$wherestr = '(lm.Emailid like "'.$email.'%")';
			$this->db->where($wherestr);
		}

		if(isset($data['sd']) && trim($data['sd']) != '')
		{
			$var = $data['sd'];
			$date = str_replace('/', '-', $var);
			$sd = date('Y-m-d', strtotime($date));
			if(strlen($date) == 10)
			{
			$sd = date('Y-m-d', strtotime($date));
			}
			

			$this->db->where('lp.flddt_exp_purchase >=',$sd);
		}

		if(isset($data['ed']) && trim($data['ed']) != '')
		{
			$var = $data['ed'];
			$date = str_replace('/', '-', $var);
			$ed = date('Y-m-d', strtotime($date));
			if(strlen($date) == 10)
			{
			$ed = date('Y-m-d', strtotime($date));
			}

			$this->db->where('lp.flddt_exp_purchase <=',$ed);
		}

		if(isset($data['name']) && trim($data['name'])!='')
		{
			$name	= $this->db->escape_str($data['name']);
			$this->db->where("(CONCAT(lm.Farmername, ' ', lm.Fathername) LIKE '%".$name."%')", NULL, false);
		}
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->limit($limit, $start);
		$this->db->order_by($orderby.' '.$ordertype );
		$query = $this->db->get();
		

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}

	public function get_all_emails($lead_id=0)
	{
		$this->db->select('le.fldv_email,le.flg_is_primary');
		$this->db->from('lead_email le');
		$this->db->where('le.fldi_lead_id',(int)$lead_id);
		$this->db->where('le.flg_is_deleted',0);
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function allocate_bulk_lead($arrLeadId = array(),$agent_id = 0)
	{
		if(is_array($arrLeadId) && count($arrLeadId)>0)
		{
			$arrData['fldi_agent_id'] = $agent_id;
			$this->db->where_in('fldi_lead_id',$arrLeadId);
			$this->db->update('tsxfarmerdetails',$arrData);
		}
		return true;
	}

	public function allocate_bulk_lead_history($arrLeadId = array(),$agent_id = 0)
	{
		if(is_array($arrLeadId) && count($arrLeadId)>0)
		{
			$data = array();
			foreach($arrLeadId as $lead_id_allocated)
			{
				$data[] = array('fldi_lead_id' => $lead_id_allocated,
							  'fldi_agent_id' => $agent_id,
							  'flddt_date_added' => date('Y-m-d H:i:s'),
							  'fldi_added_by' =>$this->crm_auth->get_id());
			}
			$this->db->insert_batch('lead_allocation_history', $data);
		}
	}

	public function get_last_allocated_group_details($lead_id=0)
	{
		$this->db->select('lm.fldi_last_group_id, gm.flg_is_lock, gm.fldi_group_id, gm.fldv_group_campaign_id, gm.fldv_group_list_name,
		gm.fldv_group_list_id');
		$this->db->from('tsxfarmerdetails lm');
		$this->db->join('group_master gm','lm.fldi_last_group_id = gm.fldi_group_id');
		$this->db->where('lm.fldi_lead_id',(int)$lead_id);
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->where('gm.flg_is_deleted',0);
		$query = $this->db->get();

		if ($query->num_rows() > 0)
		{
			return $query->row_array();
		}
		return false;

	}
	
	function is_upcoming_callack_exists($data=array())
	{
		$this->db->select('lh.fldi_lead_id');
		$this->db->from('lead_history lh');
		$this->db->where('lh.flg_history_type',1);
		$this->db->where('lh.fldi_lead_id',(int)$data['lead_id']);
		$this->db->where_in('lh.fldi_disposition_id',$data['callback']);
		$this->db->where('lh.flddt_call_back >',date('Y-m-d H:i:s'));
		$this->db->where('lh.flg_is_callback_done',0);
		$total_records =   $this->db->count_all_results();

		return  $total_records;

	}
	
	public function updateAsRLead($lead_id='')
	{
		$this->db->where('fldi_lead_id',(int)$lead_id);
		$this->db->set('flg_viewed',"0",FALSE);
		$this->db->update('tsxfarmerdetails');
	}
	
	public function update_expired_callback($data = array())
	{
		$arrData							= array();
		$arrData['fldi_updated_by']			= $this->crm_auth->get_id();
		$arrData['flg_is_callback_done']	= 1;
		$arrData['fldv_disposition_attr']	= 'Auto Call Done - Lead allocate';
		$arrData['flddt_date_updated']		= date('Y-m-d H:i:s');
		
		$this->db->where('flddt_call_back <=',date('Y-m-d H:i:s'));
		$this->db->where_in('fldi_disposition_id',$data['callback']);
		$this->db->where('flg_is_callback_done',0);
		$this->db->where('fldi_lead_id',(int)$data['lead_id']);
		$this->db->update('lead_history',$arrData);
	}
	
	public function get_all_leads_by_phone($phone = '',$connected = '')
	{
		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->where('lm.Mobileno',$this->db->escape_str($phone));
		if(trim($connected) != '')
		{
			$this->db->where('lm.fldi_connected',(int)$connected);
		}
		$this->db->where('lm.flg_is_deleted',0);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_lead_id_by_dealer_farmer($arrData = array())
	{
		$this->db->select('fldi_lead_id');
		$this->db->from('tsxfarmerdetails');
		$this->db->where('DealerCode',$this->db->escape_str($arrData['DealerCode']));
		$this->db->where('Farmerid',$this->db->escape_str($arrData['Farmerid']));
		$this->db->where('flg_is_deleted',0);
		$query = $this->db->get();
		$data['totalRows']   = $query->num_rows();
		$data['arrData']     = array();
		$cust_lead_id		 = 0;
		if ( $data['totalRows']  > 0)
		{
			 $arrData 			 = $query->row_array();
			 $cust_lead_id		 = $arrData['fldi_lead_id'];
		}
		return $cust_lead_id;

	}

	public function add_duplicate($arrData = array())
	{
		$this->db->insert('dup_farmer',$arrData);
		return true;
	}
	
	public function add_file($arrData = array())
	{
		$this->db->insert('excel_file',$arrData);
		$fldi_id = $this->db->insert_id();

		return $fldi_id;
	}
	
	public function update_file($arrData = array(),$id=0)
	{
		$this->db->where('fldi_id',(int)$id);
		$this->db->update('excel_file',$arrData);
		return true;
	}
	
	public function update_history($arrData=array(), $history_id=0)
	{
		$this->db->where('fldi_lead_history_id',$history_id);
		$this->db->update('lead_history',$arrData);
	}
	
	public function get_connected_for_history_id($data = array())
	{
		$this->db->select('lh.fldi_disposition_id,lh.fldi_lead_id');
		$this->db->from('lead_history lh');
		$this->db->join('disposition_status ds','ds.fldi_disposition_id = lh.fldi_disposition_id');
		$this->db->where('lh.fldi_lead_history_id',(int)$data['hid']);
		$this->db->where('lh.fldi_added_by >=',1);
		$this->db->where('ds.flg_status',1);
		$this->db->where('lh.flg_history_type',1);
		$this->db->where('ds.flg_is_deleted',0);
		
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return true;
		}
		return false;

	}
	
	public function getCropCultivationDetails($arrData = array())
	{
		$this->db->from('tsxcropcultivation');
		$this->db->where('Farmerid',$arrData['Farmerid']);
		$this->db->where('DealerCode',$arrData['DealerCode']);
		$this->db->limit(3);
		$query 				 = $this->db->get();
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->result_array();
			 $query->free_result();
			 return $arrData;
		}
		return false;

	}
	
	public function getAllCorpsMaster()
	{
		$this->db->select('CONCAT(apm_tagcode_vc,apm_code_vc) AS cropcode, apm_name_vc AS cropname',false);
		$this->db->from('adm_policy_mst as am');
		$this->db->where('am.apm_tagcode_vc','CS');
		$this->db->where('am.sys_active_c','A');
		$query = $this->db->get();
		return $query->result_array();
	}
	
	public function get_unsent_farmer_details()
	{
		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->where('lm.flg_transferred',0);
		$this->db->where('lm.fldi_attempted >', 0);
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->limit(100);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_unsent_dealer_farmer_details()
	{
		$this->db->select('lm.fldi_lead_id');
		$this->db->from('tsxfarmerdetails as lm');
		$this->db->where('lm.DealerCode !=', '');
		$this->db->where('lm.Farmerid !=', '');
		$this->db->where('lm.Villagecode !=', '');
		$this->db->where('lm.flg_transferred',0);
		$this->db->where('lm.flg_is_deleted',0);
		$this->db->order_by('lm.fldi_lead_id','desc');
		$this->db->limit(100);
		$query = $this->db->get();
		//print_r($this->db->last_query());exit;
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function get_unsent_requirement_details()
	{
		$this->db->select('DISTINCT(lm.fldi_lead_id) as fldi_lead_id,fm.flg_transferred',false);
		$this->db->from('lead_solutions as lm');
		$this->db->join('tsxfarmerdetails as fm','lm.fldi_lead_id = fm.fldi_lead_id');
		$this->db->where('lm.flg_transferred',0);
		$this->db->limit(100);
		$query = $this->db->get();
		if ($query->num_rows() > 0)
		{
			return $query->result_array();
		}
		return false;
	}
	
	public function update_farmer_transfered($arrData = array(),$farmer_id = 0,$dealerCode = 0)
	{
		$this->db->where('Farmerid',$this->db->escape_str($farmer_id));
		if(!empty($dealerCode))
		{
			$this->db->where('DealerCode',$this->db->escape_str($dealerCode));
		}
		
		$this->db->update('tsxfarmerdetails',$arrData);
		return true;
	}
	
	public function update_requirement($arrData = array(), $lead_req_id = '')
	{
		$this->db->where('fldi_lead_solution_id',$lead_req_id);
		$this->db->update('lead_solutions',$arrData);
		return true;
	}
	
	public function get_leadrequirement_tosend($leadid = '')
	{
		$this->db->from('lead_solutions');
		$this->db->where('fldi_lead_id',(int)$leadid);
		$this->db->where('flg_transferred',0);
		$query 				 = $this->db->get();
		
		if ($query->num_rows() > 0)
		{
			 $arrData 			 = $query->result_array();
			 $query->free_result();
			 return $arrData;
		}
		return false;
	}
	
	public function add_missed_log($arrData = array())
	{
		$this->db->insert('missed_call',$arrData);
		$fldi_missed_id = $this->db->insert_id();

		return $fldi_missed_id;
	}

	public function update_missed_log($arrData = array(),$hdn_id = 0)
	{
		$this->db->where('fldi_missed_id',$hdn_id);
		$this->db->update('missed_call',$arrData);
		return true;
	}
	
	public function countUpdateTalkTime($lead_id = '',$length_in_sec = 0)
	{
		if(empty($length_in_sec))
		{
			$length_in_sec	= 0;
		}
		
		$this->db->where('fldi_lead_id',$lead_id);
		$this->db->set('fldf_talk_time',"(fldf_talk_time+".$length_in_sec.")",FALSE); 
		$this->db->update('tsxfarmerdetails');
	}
	
	
}
