<?php
defined('BASEPATH') OR exit('No direct script access allowed');
?>
<?php include('includes/header.php');?>
<link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css" rel="stylesheet">
<!-- Page Content -->
    <div class="page-heading header-text">
      <div class="container">
        <div class="row">
          <div class="col-md-12">
            <h1>CUSTOMER SUCCESS SPECIALIST</h1>
          </div>
        </div>
      </div>
    </div>
	
<div class="container">
  <div class="row">
	<div class="col-md-12">
	  <div class="job-description">
		<h2>CUSTOMER SUCCESS SPECIALIST</h2>
		<div class="pb-3">
			<p><i class="fas fa-map-marker-alt"></i> Location: Mumbai, India</p>
			<p><i class="fas fa-clock"></i> Full-time</p>
		</div>
		
		<h4 class="mb-3 pt-3">Job Profile</h4>
		<p class="mb-2">We're looking for a proactive and customer-oriented Customer Success Specialist to join our dynamic team.</p>
		<p class="mb-2">In this role, you'll be instrumental in onboarding new customers and ensuring they receive the full benefits of our product.</p>
		<p class="mb-2">Your responsibilities will include managing the implementation process, being the go-to contact for customer inquiries, configuring software elements, and coordinating with other teams for complex integrations or customizations. You'll advocate for customer needs, respond to feedback, and actively engage with customers to promote successful outcomes.</p>
		<p class="mb-2">If you're passionate about customer success and adept at juggling multiple projects, we'd love to have you on board.</p>
		
		<h4 class="mb-3 pt-3">Responsibilities</h4>
		<ul class="respon-list">
		  <li>Serve as a project manager for successful product implementation.</li>
		  <li>Act as a dedicated contact for new customers, answering questions and providing advice.</li>
		  <li>Configure basic software elements and coordinate complex data migrations or custom integrations.</li>
		  <li>Arrange training sessions and assist with webinars.</li>
		  <li>Advocate for customers by capturing feature requests and feedback.</li>
		  <li>Respond to NPS survey feedback and address concerns.</li>
		  <li>Proactively contact customers post-implementation based on account health metrics.</li>
		  <li>Plan campaigns to address setup or usage issues.</li>
		  <li>Participate in calls with Account Managers or Sales for functionality explanations or custom service documentation.</li>
		  <li>Prepare implementation plans with project milestones for custom projects.</li>
		</ul>
		
		
		<h4 class="mb-3 pt-3">Skills Required</h4>
		<ul>
		  <li><i class="fas fa-check-circle skill-icon" ></i> 2+ years relevant experience in support, customer success, account management, sales, or similar roles.</li>
		  <li><i class="fas fa-check-circle skill-icon" style="color: #ed3237;"></i> Bonus points for previous experience in project management, onboarding, SaaS, or recruiting/HR.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Bachelor's degree.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Tech-savvy with the ability to quickly learn and explain products.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Analytical skills for creative problem-solving.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Excellent communication skills, both verbal and written.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Ability to prioritize and manage time effectively across multiple projects.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Eagerness to improve existing processes and try new ideas.</li>
		  <li><i class="fas fa-check-circle skill-icon"></i> Passion for delivering a fantastic customer experience.</li>
		</ul>
		<h4 class="mb-3 pt-3">Experience Required</h4>
		<p>Minimum 2 years</p>
		<h4 class="mb-3 pt-3">Payment</h4>
		<p>&#8377; 1,40,000 - &#8377; 2,80,000 per annum</p>
		<a href="https://survey.jamoutsourcing.com/hiring/career"><button class="apply-button mt-3"><i class="fas fa-paper-plane"></i> Apply Now</button></a>
	  </div>
	</div>
  </div>
</div>

<?php include('includes/footer.php');?>